Imports Syncfusion.Windows.Forms.Grid
Public Class Form1

  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Me.grdCB_EPA.Model.CutPaste.ClipboardFlags += GridDragDropFlags.NoAppendRows + GridDragDropFlags.RowHeader + GridDragDropFlags.ColHeader + GridDragDropFlags.NoAppendCols - GridDragDropFlags.Styles

  
        Dim i As Integer

        For i = 1 To 98
            grdCB_EPA(0, i).CellValue = "Source" & " " & i
        Next

  End Sub

  
  Private Sub grdCB_EPA_PasteCellText(ByVal sender As System.Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridPasteCellTextEventArgs) Handles grdCB_EPA.PasteCellText


        If CType(e.Style, Syncfusion.Windows.Forms.Grid.GridStyleInfo).ReadOnly Then
            e.Cancel = True
        End If

        Try
            Dim i As Single = Single.Parse(e.Text)
            Select Case i
                Case 0, 601.0F To 699.0F
                Case Else
                    Throw New Exception("")
            End Select
        Catch
            MessageBox.Show("Paste function terminated.  Data doesn't match cell type or is outside of cell value limits.", _
              "QUASAR:  Edit Cell Value Warning", MessageBoxButtons.OK, _
              MessageBoxIcon.Warning)
            e.Abort = True
        End Try


    End Sub

    Dim IsHeaderCopied As Boolean = False
    Dim CopyRangeList As GridRangeInfoList = GridRangeInfoList.Empty
    Private Sub grdCB_EPA_ClipboardCanCopy(ByVal sender As System.Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCutPasteEventArgs) Handles grdCB_EPA.ClipboardCanCopy
        CopyRangeList = New GridRangeInfoList()
        e.RangeList.CopyTo(CopyRangeList, 0)
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Console.WriteLine(Me.grdCB_EPA.Model.Data.Modified)
        Me.grdCB_EPA.Model.Data.ResetModified()
    End Sub

    Private Sub grdCB_EPA_ClipboardPaste(ByVal sender As System.Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCutPasteEventArgs) Handles grdCB_EPA.ClipboardPaste

        Dim model As GridModel = sender
        Dim cRangeList As GridRangeInfoList = New GridRangeInfoList()
        For Each range As GridRangeInfo In CopyRangeList
            If range.IsCols Then
                cRangeList.Add(GridRangeInfo.Cells(model.Rows.HeaderCount + 1, range.Left, model.RowCount, range.Right))
            Else
                cRangeList.Add(range)
            End If
        Next
        If Not cRangeList.Equals(GridRangeInfoList.Empty) Then
            model.CutPaste.CopyTextToClipboard(cRangeList)
        End If
        
    End Sub
End Class
